package com.madeu.controller.mobile.mobileevent;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobileevent.MobileEventService;
import com.madeu.service.mobile.mobilelogin.MobileLoginService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller

public class MobileEventController extends ManagerDraftAction {

	@Autowired
	private MobileEventService mobileEventService;

	/**
	 * 이벤트 상세 화면 이동
	 * 페이지 처리 없음
	 * request:
	 * response : msgCode, msgDesc
	 *
	 * @param request
	 * @return
	 */
	@RequestMapping(value = "/mobileevent/selectEventIntro.do")
	public String selectEvent(HttpSession session, HttpServletRequest request, Model model) {
		log.debug("MobileEventController  selectEvent START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try {
			if (!mobileCheckLogin(session)) {
				return "/mobile/login/login";
			} else {
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
			}
		} catch (Exception e) {
			e.printStackTrace();
			return "/mobile/login/login";
		}
		log.debug("MobileEventController  reservationIntro END");
		return "/mobile/event/selectEvent";
	}

	/**
	 * 이벤트 정보 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value = "/mobileevent/selectEvent.do")
	public ModelAndView selectEvent(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileEventController selectEvent START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileEventService.selectEvent(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileEventController selectEvent END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

}